<template>
  <div style="max-width: 1360px; padding: 0; margin: auto;">
    <q-breadcrumbs style="margin: 50px 0 20px 0; box-shadow: 1px 1px 1px 1px rgba(0,0,0,0), -1px 0 5px -3px" >
      <q-breadcrumbs-el style="font-size: 20px; margin-bottom: 4px;margin-left: 20px" label="Home" />
      <q-breadcrumbs-el style="font-size: 20px; margin-bottom: 4px" :label="product.product_type.product_type" v-if="product" />
      <q-breadcrumbs-el style="font-size: 20px; margin-bottom: 4px" :label="product.product_category.category" v-if="product" />
      <q-breadcrumbs-el style="font-size: 20px; margin-bottom: 4px" label="Detail Product" />
    </q-breadcrumbs>
    <div class="row" style="width: 100%">
      <div class="col-md-3" style="text-align: center; ">
        <div class="caption vertical-center text-left" style="margin-left: 0; margin-top: 19px">
          <q-img :src="product.main_image" v-if="product.main_image != ''" />
          <q-img src="~assets/no_photo.png" v-else />
        </div>
      </div>
      <div class="col-md-9" style="width: 73%; margin-left:20px" >
        <div class="row">
          <h4 class="text-weight-bolder" style="margin: 10px 10px 10px 0px" >{{ product.name_product }}</h4>
          <q-btn style="margin-left: auto; margin-right: 0; margin-top:15px; height: 60px; width: 220px" type="a" :to="'/product/hire/' + product.id" color="blue" label="Apply" />
        </div>
        <div class="row" style="margin-top: -20px">
          <p class="text-weight-bolder"  v-if="product.price != 0" style="font-size: 18px; margin-top: 10px; color:orange">{{product.price | currency }} </p>
          <p class="text-weight-bolder"  v-if="product.price == 0" style="font-size: 18px; margin-top: 10px; color:orange">{{ product.starting_price | currency  }} - {{ product.final_price | currency  }} </p>
          <p class="text-weight-bolder" style="font-size: 30px; margin: 0px 20px 0px 20px" >|</p>
          <p class="text-weight-bolder" style="font-size: 18px; margin-top: 10px">{{ (product.owner) ? product.owner.name : "JARKONS" }}</p>
          <p class="text-weight-bolder" style="font-size: 30px; margin: 0px 20px 0px 20px" >|</p>
          <q-icon name="location_on" style="font-size: 25px; margin-top: 12px"></q-icon>
          <p class="text-weight-bolder" v-if="product.address" style="font-size: 18px; margin-top: 10px">{{ (product.address.kota) ? product.address.kota.name : "Indonesia" }}</p>
        </div>
        <div style="width: 80%;">
          <p>{{ product.desc_product }}</p>
        </div>
      </div>
    </div>
    <div class="col-md-12" style="width: 100%; padding: 0; margin-left: auto; margin-right: auto; margin-top: 50px; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50" >
      <div style="width: 100%; padding: 0;"  class="q-pa-md">
        <div class="q-gutter-y-md" style="width: 100%">
          <q-card>
            <q-tabs
              v-model="tab"
              dense
              class="text-grey"
              active-color="green"
              indicator-color="green"
              align="justify"
              narrow-indicator
            >
              <q-tab :name="indeks" :label="indeks" v-for="(dataa, indeks) in dataCustom" v-bind:key="indeks" />
            </q-tabs>
            <q-separator />
            <q-tab-panels v-model="tab" animated >
              <q-tab-panel :name="indeks" :label="indeks" v-for="(dataa, indeks) in dataCustom" v-bind:key="indeks">
                <q-card v-for="(dataForm, indekss) in dataa" v-bind:key="indekss">
                  <q-card-section>
                    <q-list>
                      <q-item v-for="(isianForm, indeksss) in dataForm.komponen" v-bind:key="indeksss" v-if="isianForm.type != 'file'">
                        <q-item-section>
                          <q-item-label>{{ isianForm.label }}</q-item-label>
                          <q-item-label caption lines="2">{{ dataForm.isi[isianForm.label] }}</q-item-label>
                        </q-item-section>

<!--                        <q-item-section side top>-->
<!--                          <q-item-label caption>{{ dataForm.isi[isianForm.label] }}</q-item-label>-->
<!--                        </q-item-section>-->
                      </q-item>
                    </q-list>
                  </q-card-section>
                </q-card>
              </q-tab-panel>
            </q-tab-panels>
          </q-card>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "DetailProductFront",
  preFetch (store) {
    store.store.dispatch("product/getDetailProduct", store.currentRoute.params.id);
  },
  mounted() {
    if (this.$q.platform.is.mobile) {
      this.$router.push("/product/-m/" + this.$route.params.id)
    }
  },
  data () {
    return {
      tab: 'Portofolio',
      slide: 1,
      expanded: false,
      dataCustom: null
    }
  },
  filters: {
    currency(price) {
      return new Intl.NumberFormat("id-ID", {
        style: "currency",
        currency: "IDR",
        minimumFractionDigits: 2
      }).format(price);
    }
  },
  computed: {
    product() {
      let dataProduct = this.$store.getters["product/getDetailProduct"];
      if (!dataProduct.product_type) {
        dataProduct.product_type = {
          product_type: null,
        }
      }
      if (!dataProduct.product_category) {
        dataProduct.product_category = {
          category: null,
        }
      }
      if (dataProduct.custom_form) {
        let form = JSON.parse(dataProduct.custom_form)
        // Accepts the array and key
        const groupBy = (array, key) => {
          // Return the end result
          return array.reduce((result, currentValue) => {
            // If an array already present for key, push it to the array. Else create an array and push the object
            (result[currentValue[key]] = result[currentValue[key]] || []).push(
              currentValue
            );
            // Return the current iteration `result` value, this will be taken as next iteration `result` value and accumulate
            return result;
          }, {}); // empty object is the initial value for result object
        };
        this.dataCustom = groupBy(form, "judul");
      }
      return this.$store.getters["product/getDetailProduct"];
    }
  }
}
</script>


<style lang="sass" scoped>

.my-card
  width: 100%
  max-width: 350px
</style>
